<template>
  <div v-bind="containerProps" class="list-container">
    <div v-bind="wrapperProps">
      <div v-for="item in list" :key="item.index" class="list-item">
        <ChatListItem
          :item="item.data"
          @getUserProfile="getUserProfile"
          @getGroupInformation="getGroupInformation($event)"
          @click="openHandlerChatRoom(item.data)"
        ></ChatListItem>
      </div>
    </div>
  </div>
</template>
<script setup>
import { useFileManagerStore } from '@/store/fileManager/fileManager.js';
import { modalController } from '@ionic/vue';
import { useVirtualList } from '@vueuse/core';
import { computed, defineProps, onBeforeMount } from 'vue';
import ChatListItem from '@/components/message/list/ListItem.vue';
import { useContactsStore } from '@/store/contacts/contacts.js';
import { useOtoStore } from '@/store/chats/otoChat.js';
import { useGroupChat } from '@/store/chats/groupChat';
import OTOChatModal from '@/components/message/OTO/index.vue';
import GroupChatRoom from '@/components/chats/modals/android/groupChatRoom/index.vue';
import { useOverallChatsStore } from '@/store/chats/overall.js';
import { detectNameForNotifChatList } from '@/helpers/overallChatListParser.js';
import { useI18n } from 'vue-i18n';
const { t } = useI18n();
const props = defineProps({
  list: {
    type: Array,
    default: () => [],
  },
});
const getterList = computed(() => {
  return props.list;
});

const { list, containerProps, wrapperProps } = useVirtualList(getterList, {
  // Keep `itemHeight` in sync with the item's row.
  itemHeight: 65,
  overscan: 10,
});

const openOTOChatRoomModal = async (chatItem) => {
  const otoStore = useOtoStore();
  otoStore.currentChatId = chatItem.chatId;
  if (!chatItem.information.name) {
    const contactStore = useContactsStore();
    const profile = contactStore.contacts.unSavedUsers.find(
      (e) => e?.uuid == chatItem.chatId,
    );
    if (profile?.nickname) chatItem.information['name'] = profile?.nickname;
  }
  requestAnimationFrame(async () => {
    const modal = await modalController.create({
      component: OTOChatModal,
      componentProps: {
        chatData: chatItem,
      },
    });
    modal.present();
  });
};

const openGroupChatRoomModal = (chatItem) => {
  const groupChatStore = useGroupChat();
  groupChatStore.currentGroup.group_id = chatItem.groupData.groupId;
  requestAnimationFrame(async () => {
    const modal = await modalController.create({
      component: GroupChatRoom,
    });
    modal.present();
    groupChatStore.updateInChatRoomStatus(true);
  });
};
const getUserProfile = async (chatItem) => {
  if (!chatItem.chatId) return;
  const contactStore = useContactsStore();
  contactStore.getUserProfileHandler(chatItem.chatId, true).then((result) => {
    const overallChatsStore = useOverallChatsStore();
    const targetChat = overallChatsStore.chatsList.find(
      (chat) => chat.chatId == chatItem.chatId,
    );
    if (targetChat) {
      targetChat.information.name = result.nickname;
      targetChat.phoneNumber = result.phone_number;
      targetChat.information.avatarFileId = result.avatarFileId;
      targetChat.information.synced = true;
    }
    chatItem.information.name = result.nickname;
    chatItem.phoneNumber = result.phone_number;
    chatItem.information.avatarFileId = result.avatarFileId;
    if (!contactStore.contactsIsLoading) {
      chatItem.information.synced = true;
    }
  });
};
const openHandlerChatRoom = (item) => {
  if (item.groupData) {
    openGroupChatRoomModal(item);
    return;
  }
  openOTOChatRoomModal(item);
};

const getGroupInformation = async (event) => {
  const fileManagerStore = useFileManagerStore();
  const groupChatStore = useGroupChat();
  switch (event.lastMessageInfo.mtype) {
    case 'grp.add':
      const adminNameAddStatus = await detectNameForNotifChatList(
        event.lastMessageInfo.from,
      );
      const userNameAddStatus = await detectNameForNotifChatList(
        event.lastMessageInfo.data.uuid,
      );
      event.lastMessageData.content = `${adminNameAddStatus} ${t(
        'tabs.message.group.addedtogroup',
      )} ${userNameAddStatus}`;
      break;
    case 'grp.rmv':
      const adminNameRemoveStatus = await detectNameForNotifChatList(
        event.lastMessageInfo.from,
      );
      const userNameRemoveStatus = await detectNameForNotifChatList(
        event.lastMessageInfo.data.uuid,
      );
      event.lastMessageData.content = `${adminNameRemoveStatus} ${t(
        'tabs.message.group.removed',
      )} ${userNameRemoveStatus}`;
      break;
    case 'grp.crt':
      const adnibNameCreateStatus = await detectNameForNotifChatList(
        event.lastMessageInfo.from,
      );
      event.lastMessageData.content = `${adnibNameCreateStatus} ${t(
        'tabs.message.group.createdgroup',
      )}`;
      break;
    case 'grp.lft':
      const userNameLeftStatus = await detectNameForNotifChatList(
        event.lastMessageInfo.from,
      );
      event.lastMessageData.content = `${userNameLeftStatus} ${t(
        'tabs.message.group.leftthegroup',
      )}`;
      break;
    case 'grp.cfg.avt':
      const adminNameUpdateAvatarStatus = await detectNameForNotifChatList(
        event.lastMessageInfo.from,
      );
      event.lastMessageData.content = `${adminNameUpdateAvatarStatus} ${t(
        'tabs.message.group.changeavatar',
      )}`;
      break;
    case 'grp.cfg.tit':
      const adminNameUpdateTitleStatus = await detectNameForNotifChatList(
        event.lastMessageInfo.from,
      );
      event.lastMessageData.content = `${adminNameUpdateTitleStatus} ${t(
        'tabs.message.group.changename',
      )}...`;
      break;
    case 'grp.cfg.avt':
      const userNameJoinStatus = await detectNameForNotifChatList(
        event.lastMessageInfo.from,
      );
      event.lastMessageData.content = `${userNameJoinStatus} ${t(
        'tabs.message.group.join',
      )}`;
      break;
  }
  const groupAvatarFileId = await groupChatStore.getGroupAvatarFileId(
    event.chatId,
  );
  if (groupAvatarFileId) {
    event.information.avatarFileId = groupAvatarFileId;
    fileManagerStore.gettingAvatarsHandler(groupAvatarFileId);
  }
  event.information.synced = true;
};

onBeforeMount(() => {
  const otoStore = useOtoStore();
  otoStore.currentChatId = '';
});
</script>
<style scoped>
.firstchar-container {
  font-weight: bold;
  font-size: calc(30px - 1vmin);
}
.item-container {
  display: flex;
  width: 100%;
  align-items: flex-end;
}
.set-center {
  align-items: center;
  font-size: calc(30px - 2vmin);
}
.list-container {
  scrollbar-width: none;
  height: 100%;
  overflow: hidden;
  padding-bottom: 15vh;
}
.list-item {
  height: 65px;
}
.list-container::-webkit-scrollbar {
  width: 0.1rem; /* Chrome/Safari/Webkit */
  display: none; /* Hide scrollbar in IE, Edge, and Firefox */
}
</style>
